<script setup lang="ts">
import { onMounted, reactive, ref, computed } from 'vue';
import { Bar } from 'vue-chartjs';
import { Chart as ChartJS, Title, Tooltip, Legend, BarElement, CategoryScale, LinearScale } from 'chart.js';
import axios from 'axios';
import type { SalaryReportResult } from '@/types/SalaryReport'
import salaryReportService from '@/service/salaryreport'
import { useAuthStore } from '@/stores/auth'
import { useUserStore } from '@/stores/user'
const authStore = useAuthStore()
ChartJS.register(Title, Tooltip, Legend, BarElement, CategoryScale, LinearScale);
const results = ref<SalaryReportResult[]>([])
const idUser = authStore.getCurrentUser()?.id;
const chartData1 = ref({
  labels: [],
  datasets: [
    {
      label: 'Salarys Report per year',
      backgroundColor: '#0f87979',
      data: []
    }
  ]
})

const chartData2 = ref({
  labels: [],
  datasets: [
    {
      label: 'Salarys Report per Month by Year',
      backgroundColor: '#f87979',
      data: []
    }
  ]
})


// async function getReportPerDayByMonthYear(month: string, year: string) {
//     const res = await salaryReportService.getSalaryReportperDay({ month: month, year: year });
//     console.log(res);

//     if (res.data) {
//         results.value = res.data.map((it: any) => {
//             return {
//                 order_date: it.order_date,
//                 total_sum: it.total_sum
//             }
//         });
//     }
//     console.log(res.data);
//     const labels = res.data.map((it: any) => {
//         return it.order_date;
//     });
//     const data = res.data.map((it: any) => {
//         return it.total_sum;
//     });
//     chartData1.value = {
//         labels: labels,
//         datasets: [
//             {
//                 label: 'Salarys Report per Day',
//                 backgroundColor: '#f87979',
//                 data: data
//             }
//         ]
//     }
// }

async function getReportPerMonthByYear(year: string) {
  const res = await salaryReportService.getSalaryReportperMonth({
    year: year,
    month: ''
  });
  console.log(res);

  if (res.data) {
    results.value = res.data.map((it: any) => {
      return {
        order_date: it.order_month,
        total_sum: it.total_sum
      }
    });
  }
  console.log(res.data);
  const labels = res.data.map((it: any) => {
    return it.order_month;
  });
  const data = res.data.map((it: any) => {
    return it.total_sum;
  });
  chartData2.value = {
    labels: labels,
    datasets: [
      {
        label: 'Salarys Report per Month by Year',
        backgroundColor: '#f87979',
        data: data
      }
    ]
  }
}
async function getReportPerMonthByID(id: number) {
  const res = await salaryReportService.getSalaryperMonthByID({
    user_Id: id
  });
  console.log(res);

  if (res.data) {
    results.value = res.data.map((it: any) => {
      return {
        salary_month: it.month,
        total_sum: it.totalSalary
      }
    });
  }
  console.log(res.data);
  const labels = res.data.map((it: any) => {
    return it.month;
  });
  const data = res.data.map((it: any) => {
    return it.totalSalary
  });
  chartData2.value = {
    labels: labels,
    datasets: [
      {
        label: 'Salarys Report per Month by ID',
        backgroundColor: '#f87979',
        data: data
      }
    ]
  }
}
async function getReportPerYearByID(id: number) {
  const res = await salaryReportService.getSalaryperYearByID({
    user_Id: id
  });
  console.log(res);

  if (res.data) {
    results.value = res.data.map((it: any) => {
      return {
        salary_year: it.year,
        total_sum: it.totalSalary
      }
    });
  }
  console.log(res.data);
  const labels = res.data.map((it: any) => {
    return it.year;
  });
  const data = res.data.map((it: any) => {
    return it.totalSalary
  });
  chartData1.value = {
    labels: labels,
    datasets: [
      {
        label: 'Salarys Report per Year by ID',
        backgroundColor: '#f87979',
        data: data
      }
    ]
  }
}
const chartOptions = reactive({
  responsive: false,
  maintainAspectRatio: true
});

const month = ref('')
const year = ref('')
const year1 = ref('')

function confirmSearch(month: string, year: string) {
  console.log(month, year);
  getReportPerDayByMonthYear(month, year)
}

function confirmSearchMonth(year: string) {
  console.log(year);
  getReportPerMonthByYear(year)
}
const role = authStore.getCurrentUser()?.role

const userStore = useUserStore()
const user = userStore.getUser(idUser)
// const branchid    = user.branchid
onMounted(async () => {

  // await getReportPerMonthByID(authStore.getCurrentUser()?.id)
  // await getReportPerYearByID(authStore.getCurrentUser()?.id)

});
</script>

<template>
  <div class="text-center">
    <h1 style="text-align: left; font-size: 50px;"><v-icon icon="mdi-account-cash" class="mr-2"></v-icon>Salary
    </h1>
  </div>
  <v-dialog v-model="dialog" persistent width="1024">
    <template v-slot:activator="{ props }">
      <v-card-title class="d-flex align-center pe-2">
        <v-spacer></v-spacer>

        <!-- search -->
        <!-- <v-text-field v-model="search" prepend-inner-icon="mdi-magnify" density="compact" label="Search"
                    single-line flat hide-details variant="solo-filled"></v-text-field>
                <v-btn class="ma-2" style="background-color: rgb(139, 82, 38)" v-bind="props">
                    <v-icon icon="mdi-cash-plus" size="25px" class="mr-2"></v-icon>
                    <div style="text-align: left">New Salary</div>
                </v-btn> -->
      </v-card-title>
      <v-tabs v-model="tab" color="brown">
        <v-tab style="color: black" :to="{ name: 'salary' }">Total</v-tab>
        <v-tab style="color: black" :to="{ name: 'pending' }">Pending</v-tab>
        <v-tab style="color: black" :to="{ name: 'paid' }">Paid</v-tab>
        <v-tab style="color: black" :to="{ name: 'graph-salary' }">Summary</v-tab>
      </v-tabs>
    </template>
  </v-dialog>
  <v-spacer></v-spacer>
  <v-card elevation="10" rounded class="pa-5">
    <h1 style="text-align: center;">Monthly Salary</h1>
    <Bar id="my-chart-id" :options="chartOptions" :data="chartData2" width="500" height="300" />
  </v-card>
  <v-spacer></v-spacer>
  <v-spacer></v-spacer>
  <v-card elevation="10" rounded class="pa-5">
    <h1 style="text-align: center;">Yearly Salary</h1>
    <Bar id="my-chart-id" :options="chartOptions" :data="chartData1" width="500" height="300" />
  </v-card>
</template>

<style scoped>
div {
  font-family: 'Kanit';
}

.v-btn {
  width: 140px;
  height: 50px;
  color: white;
  font-family: Verdana, sans-serif;
}
</style>